----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/17/2017 08:57:04 AM
-- Design Name: 
-- Module Name: FSM_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FSM_sim is
--  Port ( );
end FSM_sim;

architecture Behavioral of FSM_sim is

    component FSM is
        Port ( Clk : in STD_LOGIC;
               Sel : in STD_LOGIC; -- put in selection mode
               PP : in STD_LOGIC;  -- play/ pause
               P_state : out STD_LOGIC_VECTOR (1 downto 0)); -- PS output for output logic
    end component;
    
    signal Clk, Sel, PP : STD_LOGIC := '0';
    
    signal P_state : STD_LOGIC_VECTOR (1 downto 0);

begin

    UUT : FSM port map (Clk => Clk, Sel => Sel, PP => PP, P_state => P_state);
    
    process begin
        Clk <= not Clk;
        wait for 5 ns;
    end process;
    
    process begin
        Sel <= '0';
        wait for 40 ns;
        
        Sel <= '1';
        wait for 10 ns;
    end process;
    
    process begin
        PP <= '0';
        wait for 10 ns;
        
        PP <= '1';
        wait for 10 ns;
    end process;

end Behavioral;
