----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 01:48:27 PM
-- Design Name: 
-- Module Name: all_output_select_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity all_output_select_sim is
--  Port ( );
end all_output_select_sim;

architecture Behavioral of all_output_select_sim is

    component all_output_select is
        Port ( Pitches : in STD_LOGIC_VECTOR (15 downto 0);
               C : in STD_LOGIC;
               Db : in STD_LOGIC;
               D : in STD_LOGIC;
               Eb : in STD_LOGIC;
               E : in STD_LOGIC;
               F : in STD_LOGIC;
               Gb : in STD_LOGIC;
               G : in STD_LOGIC;
               Ab : in STD_LOGIC;
               A : in STD_LOGIC;
               Bb : in STD_LOGIC;
               B : in STD_LOGIC;
               Tone : out STD_LOGIC_VECTOR (3 downto 0));
    end component;
    
    signal Pitches : STD_LOGIC_VECTOR (15 downto 0) := x"0000";
    
    signal Tone : STD_LOGIC_VECTOR (3 downto 0) := "0000";
    
    signal C, Db, D, Eb, E, F, Gb, G, Ab, A, Bb, B : STD_LOGIC := '0';

begin

    UUT : all_output_select port map (Pitches => Pitches, Tone => Tone, C => C, DB => DB, D => D,
            EB => EB, E => E, F => F, GB => GB, G => G, AB => AB, A => A, BB => BB, B => B);
            
    process begin
        C <= not C;
        wait for 1 ns;
    end process;

    process begin
        Db <= not Db;
        wait for 2 ns;
    end process;

    process begin
        D <= not D;
        wait for 3 ns;
    end process;

    process begin
        EB <= not EB;
        wait for 4 ns;
    end process;

    process begin
        E <= not E;
        wait for 5 ns;
    end process;

    process begin
        F <= not F;
        wait for 6 ns;
    end process;

    process begin
        GB <= not GB;
        wait for 7 ns;
    end process;

    process begin
        G <= not G;
        wait for 8 ns;
    end process;

    process begin
        AB <= not AB;
        wait for 9 ns;
    end process;

    process begin
        A <= not A;
        wait for 10 ns;
    end process;

    process begin
        BB <= not BB;
        wait for 11 ns;
    end process;

    process begin
        B <= not B;
        wait for 12 ns;
    end process;
    
    process begin
        Pitches <= "0001001000110100";
        wait for 40 ns;
        
        Pitches <= "1100101110101001";
        wait for 40 ns;
        
        Pitches <= "1111000011110001";
        wait;
    end process;

end Behavioral;
