----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 08:40:43 AM
-- Design Name: 
-- Module Name: fin_sel_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity fin_sel_sim is
--  Port ( );
end fin_sel_sim;

architecture Behavioral of fin_sel_sim is

    component fin_sel is
        Port ( PS : in STD_LOGIC_VECTOR (1 downto 0);
               DAC_input : in STD_LOGIC_VECTOR (15 downto 0);
               Pitches : in STD_LOGIC_VECTOR (15 downto 0);
               Clk_BPM : in STD_LOGIC;
               DAC : out STD_LOGIC_VECTOR (3 downto 0);
               SSEG_pitch : out STD_LOGIC_VECTOR (3 downto 0));
    end component;

    signal Clk_BPM : STD_LOGIC := '0';
    
    signal PS : STD_LOGIC_VECTOR (1 downto 0) := "00";
    
    signal DAC, SSEG_pitch : STD_LOGIC_VECTOR (3 downto 0) := "0000";
    
    signal DAC_input, Pitches : STD_LOGIC_VECTOR (15 downto 0) := "1111000011110000";

begin

    UUT : fin_sel port map (Clk_BPM => Clk_BPM, PS => PS, DAC_input => DAC_input,
            Pitches => Pitches, DAC => DAC, SSEG_pitch => SSEG_pitch);
            
    process begin
        Clk_BPM <= not Clk_BPM;
        wait for 10 ns;
    end process;
    
    process begin
        PS <= "01";
        wait;
    end process;
            
    Pitches <= "0001001000110100";
    
    process begin
        DAC_input(15 downto 12) <= not DAC_input(15 downto 12);
        wait for 1 ns;
    end process;
    
    process begin
        DAC_input (11 downto 8) <= not DAC_input (11 downto 8);
        wait for 2 ns;
    end process;

    process begin
        DAC_input (7 downto 4) <= not DAC_input (7 downto 4);
        wait for 3 ns;
    end process;

    process begin
        DAC_input (3 downto 0) <= not DAC_input (3 downto 0);
        wait for 4 ns;
    end process;

end Behavioral;
