----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 11:56:59 PM
-- Design Name: 
-- Module Name: output_fsm_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity output_fsm_sim is
--  Port ( );
end output_fsm_sim;

architecture Behavioral of output_fsm_sim is

    component output_FSM is
        Port ( Clk_BPM : in STD_LOGIC;
               FSM1_state : in STD_LOGIC_VECTOR (1 downto 0);
               Pitch_in : in STD_LOGIC_VECTOR (15 downto 0);
               Pitch_out : out STD_LOGIC_VECTOR (3 downto 0));
    end component;
    
    signal Clk_BPM : STD_LOGIC := '0';
    
    signal FSM1_state : STD_LOGIC_VECTOR (1 downto 0) := "00";
    
    signal Pitch_in : STD_LOGIC_VECTOR (15 downto 0) := x"0000";
    
    signal Pitch_out : STD_LOGIC_VECTOR (3 downto 0) := "0000";

begin

    UUT : output_FSM port map (Clk_BPM => Clk_BPM, FSM1_state => FSM1_state,
             Pitch_in => Pitch_in, Pitch_out => Pitch_out);
       
    process begin
        Clk_BPM <= not Clk_BPM;
        wait for 5 ns;
    end process;
    
    process begin
        FSM1_state <= "00";
        wait for 20 ns;
        
        FSM1_state <= "10";
        wait for 20 ns;
        
        FSM1_state <= "01";
        wait for 100 ns;
        
        FSM1_state <= "10";
        wait;
    end process;
    
    process begin
        Pitch_in <= x"f0f0";
        wait for 40 ns;
        
        pitch_in <= x"4321";
        wait;
    end process;

end Behavioral;
