----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/26/2017 05:11:37 PM
-- Design Name: 
-- Module Name: output_select_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity output_select_sim is
--  Port ( );
end output_select_sim;

architecture Behavioral of output_select_sim is

    component output_select is
        Port (   Pitch : in STD_LOGIC_VECTOR (3 downto 0);
                     C : in STD_LOGIC;
                    Db : in STD_LOGIC;
                     D : in STD_LOGIC;
                    Eb : in STD_LOGIC;
                     E : in STD_LOGIC;
                     F : in STD_LOGIC;
                    Gb : in STD_LOGIC;
                     G : in STD_LOGIC;
                    Ab : in STD_LOGIC;
                     A : in STD_LOGIC;
                    Bb : in STD_LOGIC;
                     B : in STD_LOGIC;
                  Tone : out STD_LOGIC); -- tone for each note
    end component;
    
    signal Pitch : STD_LOGIC_VECTOR (3 downto 0);
    
    signal C, Db, D, Eb, E, F, Gb, G, Ab, A, Bb, B, Tone : STD_LOGIC := '0';

begin

    UUT : output_select port map (Pitch => Pitch, Tone => Tone, C => C, Db => Db, 
            D => D, Eb => Eb, E => E, F => F, Gb => Gb, G => G, Ab => Ab, A => A,
            Bb => Bb, B => B);
    
    process begin
        C <= not C;
        wait for 1 ns;
    end process;
    
    
    process begin    
        Db <= not Db;
        wait for 3 ns;
    end process;
    
    process begin
        D <= not D;
        wait for 5 ns;
    end process;
    
    process begin
        Pitch <= "0001";
        wait for 10 ns;
        
        Pitch <= "0010";
        wait for 10 ns;
        
        Pitch <= "0000";
        wait for 10 ns;
        
        Pitch <= "0011";
        wait for 10 ns;
        
        Pitch <= "1111";
        wait;
    end process;
        
end Behavioral;
