----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/21/2017 04:12:32 PM
-- Design Name: 
-- Module Name: seg_display_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity seg_display_sim is
--  Port ( );
end seg_display_sim;

architecture Behavioral of seg_display_sim is

    component seg_display is
        Port ( Pitch : in STD_LOGIC_VECTOR (3 downto 0); -- binary number for each pitch, used in play mode
               Freq : in STD_LOGIC_VECTOR (3 downto 0); -- freq corresponding to switch positions, used in selection mode
               P_state : in STD_LOGIC_VECTOR (1 downto 0); -- output depends on state
               Clk_240Hz : in STD_LOGIC; -- switching between anodes
               Cathode : out STD_LOGIC_VECTOR (6 downto 0); 
               Anode : out STD_LOGIC_VECTOR (3 downto 0));
    end component;

    signal Pitch, Freq, Anode : STD_LOGIC_VECTOR (3 downto 0);
    
    signal Cathode : STD_LOGIC_VECTOR (6 downto 0);
    
    signal P_state : STD_LOGIC_VECTOR (1 downto 0);
    
    Signal Clk_240Hz : STD_LOGIC := '0';
    
begin

    UUT : seg_display port map (Pitch => Pitch, Freq => Freq, P_state => P_state, Clk_240Hz => Clk_240Hz, Cathode => Cathode, Anode => Anode);
    
    process begin
        Clk_240Hz <= not Clk_240Hz;
        wait for 5 ns;
    end process;
    
    process begin
       P_state <= "01";
       Pitch <= "0001";
       wait for 30 ns;
       
       Pitch <= "0010";
       wait for 30 ns;

       Pitch <= "0011";
       wait for 30 ns;

       Pitch <= "0100";
       wait for 30 ns;

    end process;

end Behavioral;