----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/27/2017 08:54:43 AM
-- Design Name: 
-- Module Name: top_block_sim - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top_block_sim is
--  Port ( );
end top_block_sim;

architecture Behavioral of top_block_sim is

    component top_block is
        Port ( Clk : in STD_LOGIC; 
               PP : in STD_LOGIC; -- play/ pause
               Sel : in STD_LOGIC; -- selection mode
               Assign : in STD_LOGIC; -- assign a note
               Freq : in STD_LOGIC_VECTOR (3 downto 0); -- frequency switches
               Step : in STD_LOGIC_VECTOR (3 downto 0); -- step switches
               DAC : out STD_LOGIC_VECTOR (3 downto 0); -- output to dac
               Anode : out STD_LOGIC_VECTOR (3 downto 0); 
               Cathode : out STD_LOGIC_VECTOR (6 downto 0));
    end component;

    signal Clk, PP, Sel, Assign : STD_LOGIC := '0';
    
    signal Freq, Step, DAC, Anode : STD_LOGIC_VECTOR (3 downto 0) := "0000";
    
    signal Cathode : STD_LOGIC_VECTOR (6 downto 0);

begin

    UUT : top_block port map (Clk => Clk, PP => PP, Sel => Sel, Assign => Assign,
            Freq => Freq, Step => Step, DAC => DAC, Anode => Anode, Cathode => Cathode);
            
    process begin
        Clk <= not Clk;
        wait for 1 ns;
    end process;
    
    process begin
        Step <= "1000";
        Freq <= "0001";
        Assign <= '1';
        wait for 10 ns;
        
        Step <= "0100";
        Freq <= "0010";
        Assign <= '1';
        wait for 10 ns;

        Step <= "0010";
        Freq <= "0011";
        Assign <= '1';
        wait for 10 ns;

        Step <= "0001";
        Freq <= "0100";
        Assign <= '1';
        wait for 10 ns;
        
        PP <= '1';
        Assign <= '0';
        wait for 3 ns;
        
        PP <= '0';
        wait;
        
    end process;

end Behavioral;
