----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/15/2017 09:01:05 AM
-- Design Name: 
-- Module Name: Clk_div_pitches - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Clk_div_pitches is
    Port ( Clk : in STD_LOGIC;
           Clk_C : out STD_LOGIC; -- pitch frequencies
           Clk_Db : out STD_LOGIC; 
           Clk_D : out STD_LOGIC;
           Clk_Eb : out STD_LOGIC;
           Clk_E : out STD_LOGIC;
           Clk_F : out STD_LOGIC;
           Clk_Gb : out STD_LOGIC;
           Clk_G : out STD_LOGIC;
           Clk_Ab : out STD_LOGIC;
           Clk_A : out STD_LOGIC;
           Clk_Bb : out STD_LOGIC;
           Clk_B : out STD_LOGIC);
end Clk_div_pitches;

architecture Behavioral of Clk_div_pitches is

    signal countC, countDb, countD, countEb, countE, countF, 
            countGb, countG, countAb, countA, countBb, countB : integer := 0;
    
    signal signalC, signalDb, signalD, signalEb, signalE, signalF,
            signalGb, signalG, signalAb, signalA, signalBb, signalB : STD_LOGIC := '0';

begin

    process (Clk)
    begin
        if (rising_edge(Clk)) then
            countC <= countC + 1; -- ambigous counters
            countDb <= countDb + 1;
            countD <= countD + 1;
            countEb <= countEb + 1;
            countE <= countE + 1;
            countF <= countF + 1;
            countGb <= countGb + 1;
            countG <= countG + 1;
            countAb <= countAb + 1;
            countA <= countA + 1;
            countBb <= countBb + 1;
            countB <= countB + 1;
            
            if (countC = 191131) then
                signalC <= not signalC;
                countC <= 0;
            end if;
            
            if (countDb = 180375) then
                signalDb <= not signalDb;
                countDb <= 0;
            end if;
            
            if (countD = 170242) then
                signalD <= not signalD;
                countD <= 0;
            end if;
            
            if (countEb = 160720) then
                signalEb <= not signalEb;
                countEb <= 0;
            end if;
            
            if (countE = 151699) then
                signalE <= not signalE;
                countE <= 0;
            end if;
            
            if (countF = 143184) then
                signalF <= not signalF;
                countF <= 0;
            end if;
            
            if (countGb = 135135) then
                signalGb <= not signalGb;
                countGb <= 0;
            end if;
            
            if (countG = 127551) then
                signalG <= not signalG;
                countG <= 0;
            end if;
            
            if (countAb = 120395) then
                signalAb <= not signalAb;
                countAb <= 0;
            end if;
            
            if (countA = 113636) then
                signalA <= not signalA;
                countA <= 0;
            end if;
            
            if (countBb = 107250) then
                signalBb <= not signalBb;
                countBb <= 0;
            end if;
                      
            if (countB = 101235) then
                signalB <= not signalB;
                countB <= 0;
            end if;
            
        end if;
        
    end process;

    Clk_C <= signalC;
    Clk_Db <= signalDb;
    Clk_D <= signalD;
    Clk_Eb <= signalEb;
    Clk_E <= signalE;
    Clk_F <= signalF;
    Clk_Gb <= signalGb;
    Clk_G <= signalG;
    Clk_Ab <= signalAb;
    Clk_A <= signalA;
    Clk_Bb <= signalBb;
    Clk_B <= signalB;

end Behavioral;

