----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/17/2017 08:36:31 AM
-- Design Name: 
-- Module Name: FSM - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FSM is
    Port ( Clk : in STD_LOGIC;
           Sel : in STD_LOGIC; -- put in selection mode
           PP : in STD_LOGIC;  -- play/ pause
           P_state : out STD_LOGIC_VECTOR (1 downto 0)); -- PS output for output logic
end FSM;

architecture Behavioral of FSM is

    signal NS, PS : STD_LOGIC_VECTOR (1 downto 0) := "00";

begin

    state : process (Clk) -- change states on clock signal
    begin
        if (rising_edge(Clk)) then
            PS <= NS;
        end if;
        
    end process;
    
    P_state <= PS;
    
    logic : process (PS, Sel, PP) -- logic behind changing states
    begin
        case (PS) is
            when "00" => -- selection state
                if (PP = '0') then
                    if (Sel = '0') then -- 0/0 stay
                        NS <= PS;
                    else                -- 0/1 stay
                        NS <= PS;
                    end if;
                else
                    if (Sel = '0') then
                        NS <= "01";     -- 1/0 > play
                    else                
                        NS <= PS;       -- 1/1 stay
                    end if;
               end if;
           when "01" => -- play state
               if (PP = '0') then
                   if (Sel = '0') then -- 0/0 stay
                       NS <= PS;
                    else                -- 0/1 > selection
                       NS <= "00";
                    end if;
               else
                   if (Sel = '0') then
                       NS <= "10";     -- 1/0 > pause
                   else                
                       NS <= PS;       -- 1/1 stay
                   end if;
               end if;
           when "10" => -- pause state
               if (PP = '0') then
                   if (Sel = '0') then -- 0/0 stay
                       NS <= PS;
                   else                -- 0/1 > selection
                       NS <= "00";
                   end if;
               else
                   if (Sel = '0') then
                       NS <= "01";     -- 1/0 > play
                   else                
                       NS <= PS;       -- 1/1 stay
                   end if;
               end if;
           when others => -- catch, should never happen
               NS <= "00";
           
        end case;
       
    end process;

end Behavioral;
