----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/19/2017 09:14:18 AM
-- Design Name: 
-- Module Name: Note_assign - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
-- Error 1: Pitch still '0' when note is '1' FIXED
-- Changed output to be 4 bit bus corresponding to each note,
-- not a specific frequency because output would not match input
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Note_assign is
    Port ( P_state : in STD_LOGIC_VECTOR (1 downto 0); -- state from PPS FSM
           Sel : in STD_LOGIC; -- unused
           Switch : in STD_LOGIC; -- positional switches, step
           Freq : in STD_LOGIC_VECTOR (3 downto 0); -- the combination of freq switches
           Assign : in STD_LOGIC; -- assign a note, bottom button
           Pitch : out STD_LOGIC_VECTOR (3 downto 0) := "0000"); -- the assigned pitch 
end Note_assign;

architecture Behavioral of Note_assign is

begin
    
    assignment : process (Assign, P_state, Freq) -- assign positional note to a frequency
    begin
        if (P_state = "00") then -- in assign state, assigns freq to positional notes pitch
                if (Switch = '1') then 
                    if (Assign = '1') then
                        Pitch <= Freq; -- output is binary #
                    end if;
                end if;
        end if;
        
    end process;
    
end Behavioral;
