----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 01:22:40 PM
-- Design Name: 
-- Module Name: all_note_assign - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity all_note_assign is
    Port ( P_state : in STD_LOGIC_VECTOR (1 downto 0);
           Step : in STD_LOGIC_VECTOR (3 downto 0);
           Freq : in STD_LOGIC_VECTOR (3 downto 0);
           Assign : in STD_LOGIC;
           Pitches : out STD_LOGIC_VECTOR (15 downto 0));
end all_note_assign;

architecture Behavioral of all_note_assign is

    component note_assign is
        Port ( P_state : in STD_LOGIC_VECTOR (1 downto 0);
               Switch : in STD_LOGIC; -- positional switches
               Freq : in STD_LOGIC_VECTOR (3 downto 0); -- the combination of freq switches
               Assign : in STD_LOGIC;
               Pitch : out STD_LOGIC_VECTOR (3 downto 0)); -- the assigned pitch 
    end component;

begin

------------> ONLY USED FOR SIM PURPOSES <-----------------------------

    -- assigning each step a pitch CHECK
    NA3 : note_assign port map (P_state => P_state, Switch => Step(3), Freq => Freq, 
            Assign => Assign, Pitch => pitches(15 downto 12));

    NA2 : note_assign port map (P_state => P_state, Switch => Step(2), Freq => Freq, 
            Assign => Assign, Pitch => pitches(11 downto 8));
            
    NA1 : note_assign port map (P_state => P_state, Switch => Step(1), Freq => Freq, 
            Assign => Assign, Pitch => pitches(7 downto 4));

    NA0 : note_assign port map (P_state => P_state, Switch => Step(0), Freq => Freq, 
            Assign => Assign, Pitch => pitches(3 downto 0));

end Behavioral;
