----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 01:45:07 PM
-- Design Name: 
-- Module Name: all_output_select - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity all_output_select is
    Port ( Pitches : in STD_LOGIC_VECTOR (15 downto 0);
           C : in STD_LOGIC;
           Db : in STD_LOGIC;
           D : in STD_LOGIC;
           Eb : in STD_LOGIC;
           E : in STD_LOGIC;
           F : in STD_LOGIC;
           Gb : in STD_LOGIC;
           G : in STD_LOGIC;
           Ab : in STD_LOGIC;
           A : in STD_LOGIC;
           Bb : in STD_LOGIC;
           B : in STD_LOGIC;
           Tone : out STD_LOGIC_VECTOR (3 downto 0));
end all_output_select;

architecture Behavioral of all_output_select is

    component output_select is
        Port ( Pitch : in STD_LOGIC_VECTOR (3 downto 0);
               C : in STD_LOGIC;
               Db : in STD_LOGIC;
               D : in STD_LOGIC;
               Eb : in STD_LOGIC;
               E : in STD_LOGIC;
               F : in STD_LOGIC;
               Gb : in STD_LOGIC;
               G : in STD_LOGIC;
               Ab : in STD_LOGIC;
               A : in STD_LOGIC;
               Bb : in STD_LOGIC;
               B : in STD_LOGIC;
               Tone : out STD_LOGIC); -- tone for each note
    end component;

begin

------------> ONLY USED FOR SIM PURPOSES <-----------------------------

    -- assigning the output a clk frequency CHECK  
    OS3 : output_select port map (Pitch => pitches(15 downto 12), C => C, Db => Db,
            D => D, Eb => Eb, E => E, F => F, Gb => Gb, G => G, Ab => Ab, A => A,
            Bb => Bb, B => B, Tone => tone(3));

    OS2 : output_select port map (Pitch => pitches(11 downto 8), C => C, Db => Db,
            D => D, Eb => Eb, E => E, F => F, Gb => Gb, G => G, Ab => Ab, A => A,
            Bb => Bb, B => B, Tone => tone(2));
            
    OS1 : output_select port map (Pitch => pitches(7 downto 4), C => C, Db => Db,
            D => D, Eb => Eb, E => E, F => F, Gb => Gb, G => G, Ab => Ab, A => A,
            Bb => Bb, B => B, Tone => tone(1));

    OS0 : output_select port map (Pitch => pitches(3 downto 0), C => C, Db => Db,
            D => D, Eb => Eb, E => E, F => F, Gb => Gb, G => G, Ab => Ab, A => A,
            Bb => Bb, B => B, Tone => tone(0));


end Behavioral;
