----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 08:34:06 AM
-- Design Name: 
-- Module Name: fin_sel - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity fin_sel is
    Port ( PS : in STD_LOGIC_VECTOR (1 downto 0); -- present state from PPS FSM
           DAC_input : in STD_LOGIC_VECTOR (3 downto 0);
           DAC : out STD_LOGIC_VECTOR (3 downto 0)); -- final output
end fin_sel;

architecture Behavioral of fin_sel is

begin

    process (PS, DAC_input)
    begin
        case (PS) is
            when "00" => -- no noise in selection state
                DAC <= "0000";
            when "01" => -- chosen notes in play state
                DAC <= DAC_input;
            when "10" => -- not noise in pause state
                DAC <= "0000";
            when others => -- catch, should never occur
                DAC <= "1111";
        end case;
            
    end process;

end Behavioral;
