----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/29/2017 11:41:41 PM
-- Design Name: 
-- Module Name: output_FSM - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity output_FSM is
    Port ( Clk_BPM : in STD_LOGIC; 
           FSM1_state : in STD_LOGIC_VECTOR (1 downto 0); -- PPS FSM state
           Pitch_in : in STD_LOGIC_VECTOR (15 downto 0); -- all pitches from NA modules
           Pitch_out : out STD_LOGIC_VECTOR (3 downto 0) := "0000"); -- one pitch outputted at a time
end output_FSM;

architecture Behavioral of output_FSM is

    signal NS, PS : STD_LOGIC_VECTOR (1 downto 0) := "00";

begin

    state: process (Clk_BPM) -- changes states on clock signal
    begin
        if (rising_edge(Clk_BPM)) then
            PS <= NS;
        end if;
    end process;
    
    logic : process (Clk_BPM, FSM1_state)
    begin
        if (FSM1_state = "01") then
                case (PS) is
                    when "00" =>
                        NS <= "01"; -- state logic
                        Pitch_out <= Pitch_in (3 downto 0); -- output logic
                    when "01" =>
                        NS <= "10";
                        Pitch_out <= Pitch_in (7 downto 4);
                    when "10" =>
                        NS <= "11";
                        Pitch_out <= Pitch_in (11 downto 8);
                    when others =>
                        NS <= "00";
                        Pitch_out <= Pitch_in (15 downto 12);
                end case;
        else -- sets back to note 1 if not in play state, outputs 0
            NS <= "00";
            Pitch_out <= "0000";
        end if;
    end process; 
end Behavioral;
