----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/25/2017 01:34:35 PM
-- Design Name: 
-- Module Name: output_select - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity output_select is
    Port ( Pitch : in STD_LOGIC_VECTOR (3 downto 0) := "0000"; -- one pitch from OFSM
           C : in STD_LOGIC; -- pitch frequencis
           Db : in STD_LOGIC;
           D : in STD_LOGIC;
           Eb : in STD_LOGIC;
           E : in STD_LOGIC;
           F : in STD_LOGIC;
           Gb : in STD_LOGIC;
           G : in STD_LOGIC;
           Ab : in STD_LOGIC;
           A : in STD_LOGIC;
           Bb : in STD_LOGIC;
           B : in STD_LOGIC;
           Tone : out STD_LOGIC := '0'); -- tone for each note, oscillates
end output_select;

architecture Behavioral of output_select is

begin

    process (Pitch, C, Db, D, Eb, E, F, Gb, G, Ab, A, Bb, B) -- choose letter note from pitch switches
    begin
        case (Pitch) is
            when "0001" => Tone <= C;
            when "0010" => Tone <= Db;
            when "0011" => Tone <= D;
            when "0100" => Tone <= Eb;
            when "0101" => Tone <= E;
            when "0110" => Tone <= F;
            when "0111" => Tone <= Gb;
            when "1000" => Tone <= G;
            when "1001" => Tone <= Ab;
            when "1010" => Tone <= A;
            when "1011" => Tone <= Bb;
            when "1100" => Tone <= B;
            when others => Tone <= '0'; -- anything else, tone won't oscillate
        end case;
               
    end process;
        
end Behavioral;
